<template>
  <nav class="navbar">
    <div class="search wp-12"
      :class="{
        'search--active': isSearchActive,
        'navbar-action--active': isActionActive,
      }">
      <font-awesome-icon class="search-icon" icon="search" size="lg"/>
      <input class="search-input" type="text" placeholder="Поиск..."
        :value="$props.value" @input="$emit('input', $event.target.value)">
      <div v-if="$props.filters" class="search-action" @click="switchFilters"
        :class="{'search-action--active': !isFiltersHidden}">
        <font-awesome-icon class="search-action__icon" icon="sliders-h"/>
        Фильтры
      </div>
      <div class="navbar-action" @click="onNavbarActionClick">
        <font-awesome-icon class="navbar-action__icon" icon="plus" size="lg"/>
      </div>
    </div>
    <div class="search-filters" v-if="!isFiltersHidden">
      <slot name="filters"/>
    </div>
  </nav>
</template>

<script>
export default {
  name: 'NavBar',
  props: {
    value: {
      required: true,
      type: String,
    },
    filters: {
      type: Boolean,
      default: false,
    },
    isActionActive: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      isFiltersHidden: true,
    };
  },
  computed: {
    isSearchActive() {
      return this.$props.value.length > 0;
    },
  },
  methods: {
    switchFilters() {
      this.isFiltersHidden = !this.isFiltersHidden;
    },
    onNavbarActionClick() {
      if (this.isSearchActive) return;
      this.$emit('action');
    },
  },
};
</script>

<style lang="scss" scoped>
.navbar {
  margin-bottom: 30px;

  .search {
    height: 60px;
    display: flex;
    justify-content: flex-start;
    align-items: center;
    background: $surface;
    border-radius: 10px;

    &--active {

      .search-icon {
        color: #000;
      }

      .navbar-action {
        background: $neutralDarker;

        &:hover {
          cursor: not-allowed;
        }

        &__icon {
          transform: rotate(45deg);
        }

      }

    }

    &-icon {
      padding: 20px 10px 20px 20px;
      color: $neutralDarker;
      transition: color ease-in-out .2s;
    }

    &-input {
      margin-right: 20px;
      flex: 1;
      font-size: 20px;
      font-family: $roboto;
      color: #000;
      border: none;
      transition: color ease-in-out .2s;

      &::placeholder {
        color: $neutralDarker;
      }

    }

    &-action {
      padding-right: 20px;
      display: flex;
      justify-content: flex-start;
      align-items: center;
      font-size: 20px;
      font-family: $firaSans;
      color: $neutralDarker;
      cursor: pointer;
      transition: color ease-in-out .2s;

      &--active {
        color: $primary;
      }

      &__icon {
        padding: 20px 10px 20px 0;
      }

    }

  }

  &-action {
    height: 60px;
    width: 60px;
    display: flex;
    justify-content: center;
    align-items: center;
    background: $primary;
    border-left: 2px solid $neutralLightest;
    border-radius: 0 10px 10px 0;
    cursor: pointer;
    transition: background ease-in-out .2s;

    &:hover {
      background: $primaryDark;
    }

    &--active {

      .navbar-action {
        background: $secondary;

        &:hover {
          background: $secondaryDark;
        }

        &__icon {
          transform: rotate(45deg);
        }

      }

    }

    &__icon {
      padding: 0;
      color: #fff;
      transition: transform ease-in-out .2s;
    }

  }

  &-filters {
    margin-top: 15px;
    min-height: 60px;
    background: #fff;
    border-radius: 5px;
  }

}
</style>
